# = Ruby ̕WCu DL g NArray ̊gCu𓮓Iɍ
#
#    (C) xV 2008/04/26
#    LICENCE: Ruby's
# 
# * NX DynamicDL -- RubyW DL ̉pCu
# * eXgvO -- NArray p̃Tv

require "dl/import"
require "mkmf"

# = Ruby ̕WYtCu DL gāAI C R[h𐶐
# 
#    (C) xV 2008/04/26
#    LICENCE: Ruby's
#
# : C\[X make t@CACut@C̓JgfBNg
# ɍ쐬B
#
# == gp@ 
# ({t@C̃eXgQlɂ.)
# 
# Ⴆ΃\[X, Cu foo.c, foo.so ƂOƂAFoo Ƃ
# W[Ŏg悤ɂɂ͎̂悤ɂ
# 
#   module Foo
#     extend DL::Importable
#     code = <<-'EOS'
#       ....  C ̃R[h
#     EOS
#     ext = DynamicDL.new(code, self.to_s.downcase)
#     dlload(ext.make)
#     ext.proto.each{|prt| extern(prt)}
#   end
# 
# ȂANArray pɂ͉L̃eXgvÔ悤 alias ŕ֗
# \bhƗǂB
# 
class DynamicDL

  PREFIX = "#include <ruby.h>\n"

  def initialize(code, libname)
    @code = PREFIX + code
    @libname = libname
    @srcname = @libname + '.c'
  end

  # R[h
  def code
    @code
  end

  # R[h_v (I)
  def dump
    @src = File.open(@srcname,'w'){|f| f.print(code)}
  end

  # R[h_v (t@CΕ)
  def dump_i
    if File.exists?(@srcname)
      print "File #{@srcname} exists. Overwrite it? [Yn]; "
      ans = gets
      raise("Execution stopped") if /^n/ =~ ans
    end
    dump
  end

  # R[h_v (t@CȂvȂꍇ)
  def dump_if_dif
    if !File.exists?(@srcname)
      dump
    else
      if code != File.read(@srcname)
        dump
      end
    end
  end

  # RpC
  def make
    dump_if_dif
    create_makefile(@libname)  # KvȂƂ݂̂ɂ...
    print "Compiling library #{@srcname}\n"
    system('make') || raise("Compilation failed.")
    libflname = @libname+'.so'
    if !File.exists?(libflname)
      raise("Library #{libflname} does not exist. May in another name?") 
    end
    libflname
  end

  DEF_PAT = /\s*\/\/\s*DEF\s*$/

  def proto
    proto = code.grep(DEF_PAT).collect{|l| 
      l.sub(DEF_PAT,"").gsub(/\s*[\w_]+\s*([,\)])/,'\1')
    }
    raise("Fucntion definition must end with '// DEF'") if proto.nil?
    proto
  end

end

if __FILE__ == $0

  module Test

    extend DL::Importable

    #< gCuR[h >
    code = <<-'EOS'
      void test_str(const char *a)  // DEF
      {
        printf("%s\n",a);
      }
      void test_double(const double *a, int a_len)  // DEF
      {
        int i;
        for(i=0;i<a_len;i++){
          printf("%f\n", a[i]);
        }
      }

      double *negative2zero(const double *a, int a_len)  // DEF
      {
        int i;
        double *b;
        b = xmalloc(a_len*sizeof(double));
        for(i=0;i<a_len;i++){
          if (a[i] >= 0){
            b[i] = a[i];
          } else {
            b[i] = 0.0;
          }
        }
        return(b);
      }
    EOS

    #< DLɂ胂W[֐ >
    ext = DynamicDL.new(code, self.to_s.downcase)
    dlload(ext.make)
    ext.proto.each{|prt| extern(prt)}

    #< NArray pɁA֗ȃ\bh` >
    alias _negative2zero_ negative2zero
    module_function :_negative2zero_
    def negative2zero(na)
      na = na.to_type(NArray::FLOAT) if na.typecode != NArray::FLOAT
      len = na.length
      ptr = _negative2zero_(na.to_s, len)
      str = ptr.to_s(len*DL.sizeof('d'))
      NArray.to_na(str, NArray::FLOAT, *na.shape)
    end
    module_function :negative2zero
  end

  require "narray"
  Test.test_str("Hello world")
  na = NArray[9.0,-3.5]
  Test.test_double(na.to_s,na.length)

  p Test.negative2zero(na)

end
